<?php
/**
 * @package   AkeebaTicketSystem
 * @copyright Copyright (c)2011-2017 Nicholas K. Dionysopoulos
 * @license   GNU General Public License version 3, or later
 */
namespace Akeeba\TicketSystem\Site\Controller;

use Akeeba\TicketSystem\Admin\Helper\Permissions;
use Akeeba\TicketSystem\Site\Controller\Mixin\Caching;
use Akeeba\TicketSystem\Site\Model\Tickets;
use FOF30\Container\Container;
use FOF30\Controller\DataController;

defined('_JEXEC') or die;

class Latest extends DataController
{
	use Caching;

	public function __construct(Container $container, array $config = [])
	{
		parent::__construct($container, $config);

		$this->modelName      = 'Tickets';

		$this->registerCacheParams();
	}

	public function execute($task)
	{
		$task = 'browse';

		return parent::execute($task);
	}

	protected function onBeforeBrowse()
	{
		$platform = $this->container->platform;

		if ($platform->getUser()->guest)
		{
			// Not a logged in user, redirect to login page
			$returl = base64_encode(\JUri::getInstance()->toString());
			$url    = \JRoute::_('index.php?option=com_users&view=login&return=' . $returl, false);

			$this->container->platform->redirect($url, \JText::_('JLIB_APPLICATION_ERROR_ACCESS_FORBIDDEN'));
		}

		// Am I manager of at least one category? If not, stop here
		if (!Permissions::getManagerCategories())
		{
			return false;
		}

		/** @var Tickets $model */
		$model           = $this->getModel();
		$model->viewName = $this->viewName;
	}
}